﻿Imports System.Data.SqlClient
Imports System.IO

Public Class frmDetallesHoja

    'Variables que utilizaremos en nuestra clase
    Dim hoja As Integer
    Dim DatasetGastos As New DataSet
    Dim cod_emp_hoja_seleccionada As Integer
    Dim referencia As Integer

    Private Sub frmDetallesHoja_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try
            txtFOrigen.ReadOnly = True
            txtFOrigen.BackColor = Color.White
            txtFDestino.ReadOnly = True
            txtFDestino.BackColor = Color.White

            txtMotivo.ReadOnly = True
            txtMotivo.BackColor = Color.White
            txtGastos.ReadOnly = True
            txtGastos.BackColor = Color.White

            Dim datasetalt As New DataSet
            Try
                datasetalt = obj.DatosHoja(hoja)
            Catch ex As Exception
                MessageBox.Show(ex.Message + "El servicio está caido")
                End
            End Try

            'Cargamos la hoja y rellenamos los controles
            Dim filahoja As DataRow
            filahoja = datasetalt.Tables(0).Rows.Find(hoja)

            lblNumero.Text = filahoja(0)
            lblCodigoDatos.Text = filahoja(1)
            cod_emp_hoja_seleccionada = filahoja(1)
            lblEstadoDatos.Text = filahoja(14)
            lblLocalidadDatos.Text = filahoja(3)
            If filahoja(4).ToString = "" Then
            Else
                txtMotivo.Text = filahoja(4)
            End If
            lblPaisDatos.Text = filahoja(5)
            txtGastos.Text = filahoja(8)
            txtFOrigen.Text = filahoja(6)
            txtFDestino.Text = filahoja(7)
            referencia = filahoja(2)



            'Liberamos memoria
            datasetalt.Dispose()

            'Bloque para tener el nombre del empleado
            Try
                lblNombreDatos.Text = obj.NombreEmpleado(cod_emp_hoja_seleccionada)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                End
            End Try


            'Bloque para determinar el origen de la referencia
            Dim esdepartamento As Boolean
            Try
                esdepartamento = obj.EsDepartamento(referencia)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                End
            End Try
            If esdepartamento Then
                lblReferenciaDatos.Text = "Departamento " + referencia.ToString
            Else
                lblReferenciaDatos.Text = "Proyecto " + referencia.ToString
            End If

            'Bloque para cargar los gastos de la hoja
            Try
                datasetalt = obj.GastosHoja(hoja)
            Catch ex As Exception
                MessageBox.Show(ex.Message + "El servicio está caido")
                End
            End Try



            'Definimos el DataGridView
            dgvGastos.DataSource = datasetalt.Tables(0)
            dgvGastos.Columns(0).Visible = False
            dgvGastos.Columns(1).Visible = False
            dgvGastos.ReadOnly = True
            dgvGastos.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
            dgvGastos.AllowUserToAddRows = False
            dgvGastos.Columns(2).HeaderCell.Style.Alignment = DataGridViewContentAlignment.TopCenter
            dgvGastos.Columns(3).HeaderCell.Style.Alignment = DataGridViewContentAlignment.TopCenter
            dgvGastos.Columns(4).HeaderCell.Style.Alignment = DataGridViewContentAlignment.TopCenter
            dgvGastos.Columns(5).HeaderCell.Style.Alignment = DataGridViewContentAlignment.TopCenter
            dgvGastos.Columns(6).HeaderCell.Style.Alignment = DataGridViewContentAlignment.TopCenter
            dgvGastos.Columns(3).DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopCenter
            dgvGastos.Columns(4).DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopRight
            dgvGastos.Columns(5).DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopRight
            dgvGastos.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopRight
            dgvGastos.Columns(7).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter
            'Liberamos memoria
            datasetalt.Dispose()

            If rol = "JefeDepartamento" Then
                ColocarJefeDepartamento()
            Else
                If rol = "JefeProyecto" Then
                    ColocarJefeProyecto()
                End If
            End If

            'En caso de estar cancelada cambiamos la colocacion de algunos controles
            If lblEstadoDatos.Text = "Cancelada" Then
                ColocarMotivo(filahoja(15))
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Public Sub New(ByVal cod_hoja As Integer)
        ' Llamada necesaria para el diseñador.
        InitializeComponent()

        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        hoja = cod_hoja

    End Sub

    Private Sub pbImprimir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbImprimir.Click
        Try
            If PrintDialog1.ShowDialog() Then
                PrintForm1.PrinterSettings = PrintDialog1.PrinterSettings

                PrintForm1.Print()
                Me.Close()
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
    '    Me.Close()
    '    frmConsultas.Show()
    'End Sub

    'Metodo que mostramos el motivo de la cancelacion de una hoja
    Private Sub ColocarMotivo(ByVal motivo As String)
        Try

            dgvGastos.Size = New Size(646, 130)
            Dim txtRechazo As New TextBox
            txtRechazo.Multiline = True
            txtRechazo.Text = motivo
            txtRechazo.Size = New Size(364, 74)
            txtRechazo.Location = New Size(164, 298)


            Dim lblRechazo As New Label
            lblRechazo.Text = "Rechazado por: "
            lblRechazo.Size = New Size(83, 13)
            lblRechazo.Location = New Size(54, 332)
            lblRechazo.ForeColor = System.Drawing.Color.Blue

            Me.Controls.Add(txtRechazo)
            Me.Controls.Add(lblRechazo)

        Catch ex As Exception
            Throw
        End Try
    End Sub

    'Metodo que muestra los controles para aprobar o rechazar una hoja para un JD
    Private Sub ColocarJefeDepartamento()

        If lblEstadoDatos.Text = "Abierta" Then
            If (referencia = dept_emp) Then
                Aprobar = True
                Me.Size = New Size(692, 592)
                btnAprobar.Visible = True
                btnRechazar.Visible = True
            Else
                Me.Size = New Size(692, 522)
                btnAprobar.Visible = False
                btnRechazar.Visible = False
            End If
        Else
            If lblEstadoDatos.Text = "Aprobada" Then
                Aprobar = False
                Me.Size = New Size(692, 592)
                btnAprobar.Visible = True
                btnRechazar.Visible = True
            End If
        End If

    End Sub

    'Metodo que muestra los controles para aprobar o rechazar una hoja para un JP
    Private Sub ColocarJefeProyecto()


        If lblEstadoDatos.Text = "Abierta" Then
            If (referencia = ProyectoResponsable) Then
                Aprobar = True
                Me.Size = New Size(692, 592)
                btnAprobar.Visible = True
                btnRechazar.Visible = True
            Else
                Me.Size = New Size(692, 522)
                btnAprobar.Visible = False
                btnRechazar.Visible = False
            End If
        End If

    End Sub

    Private Sub btnAprobar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAprobar.Click
        Try
            'Si es para aprobar la aprobamos, si es para autorizar, autorizamos
            If Aprobar Then
                Dim dr As DialogResult
                dr = MessageBox.Show("¿Está seguro que desea aprobar la hoja de gastos?", "Aprobar", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

                If (dr = Windows.Forms.DialogResult.Yes) Then
                    Dim comprobar As Boolean
                    comprobar = obj.AprobarHoja(hoja, cod_emp)

                    If comprobar Then
                        Me.Close()
                    Else
                        MessageBox.Show("Se ha producido un error")
                        Me.Close()
                    End If
                End If
            Else
                Dim dr As DialogResult
                dr = MessageBox.Show("¿Está seguro que desea autorizar la hoja de gastos?", "Autorizar", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

                If (dr = Windows.Forms.DialogResult.Yes) Then

                    Dim comprobar As Boolean
                    comprobar = obj.AutorizarHoja(hoja, cod_emp)

                    If comprobar Then
                        Me.Close()
                    Else
                        MessageBox.Show("Se ha producido un error")
                        Me.Close()
                    End If
                End If
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub btnRechazar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRechazar.Click
        Try
            'En caso de rechazar, rellenamos el motivo en una ventana nueva que sacamos.
            ' Y cancelamos la hoja
            Dim motivo As String
            Using Ventana As New frmMotivo()

                Dim dr As DialogResult = Ventana.ShowDialog(Me)

                If (dr = Windows.Forms.DialogResult.OK) Then
                    'MessageBox.Show("TEST")
                    motivo = Ventana.Motivo_rechazo

                    Dim comprobar As Boolean
                    comprobar = obj.RechazarHoja(hoja, motivo)
                    If comprobar Then
                        Me.Close()
                    Else
                        MessageBox.Show("Se ha producido un error")
                        Me.Close()
                    End If

                Else
                    MessageBox.Show("Debe introducir un motivo. No se ha podido llevar a cabo la accion indicada", "Falta motivo", MessageBoxButtons.OK, MessageBoxIcon.Error)
                End If
            End Using


        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Metodo para leer el archivo PDF y poder guardarlo
    Private Sub LeerArchivo(ByVal datos As Byte(), ByVal ruta As String)
        If datos Is Nothing Then
            Throw New ArgumentException("No se ha especificado ningun array de bytes")
        End If

        If String.IsNullOrEmpty(ruta) Then
            Throw New ArgumentException("No se ha especificado la ruta")
        End If
        Try

            If File.Exists(ruta) Then
                Dim dr As DialogResult

                dr = MessageBox.Show("Ya existe un archivo con el mismo nombre. ¿Desea sobreescribirlo?", "Archivo existente", MessageBoxButtons.YesNo)

                If dr = Windows.Forms.DialogResult.Yes Then
                    File.Delete(ruta)
                End If
            End If

            Dim numero As Integer = datos.Length

            Dim nombre_archivo As String = Path.GetTempFileName

            Using fs As New FileStream(nombre_archivo, FileMode.OpenOrCreate)
                Dim bw As New BinaryWriter(fs)
                bw.Write(datos, 0, numero)
                bw.Flush()
                bw = Nothing
            End Using

            File.Move(nombre_archivo, ruta)
        Catch ex As Exception
            Throw
        End Try

    End Sub

    'Metodo para leer el archivo adjunto
    Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click
        Try

            Dim datos() As Byte = obj.RecuperarAdjunto(hoja)

            If datos Is Nothing Then
                MessageBox.Show("No hay ningun archivo adjunto")
            Else
                SaveFileDialog1.Filter = "Archivos PDF|*.pdf"
                SaveFileDialog1.Title = "Selecciona la ubicacion donde guardar el archivo"
                If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                    LeerArchivo(datos, SaveFileDialog1.FileName)
                    System.Diagnostics.Process.Start(SaveFileDialog1.FileName)
                End If
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
End Class