﻿Imports System.Data.SqlClient
Imports Microsoft.VisualBasic.PowerPacks

Public Class frmNdG


    'Variables para determinar el nombre del departamento y su jefe
    Dim nombre_dept As String
    Dim jefe_dept As Integer
    'Dim AdapHoja As New SqlDataAdapter

    'Variables para controlar que tipo de jefe es
    Dim EsJefeDepartamento As Boolean = False
    Dim EsJefeProyecto As Boolean = False

    'Variables para controlar la ultima hoja
    Dim UltimaHoja As Integer
    Dim EstadoUltimaHoja As String = ""

    'Tabla que tendrá las hojas
    Dim TablaHojas As New DataTable

    'Vistas para filtrar las hojas
    Dim dvHojasDepPendientesAprobar As DataView
    Dim dvHojasDepPendientesAutorizar As DataView
    Dim dvHojasProyPendientesAprobar As DataView

    'GroupBox para el jefe de proyecto o departamento
    Dim gbGeneral As New GroupBox

    Private Sub frmNdG_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Try

            'Mostramos el formulario de login primero. En caso de no ser valido de que se cancele
            'salimos de la aplicacion
            Using frm As New frmLogin
                Dim dr As New DialogResult
                Me.Hide()
                dr = frmLogin.ShowDialog(Me)

                If dr <> Windows.Forms.DialogResult.OK Then
                    Application.Exit()
                End If
            End Using


            ' Mediante nuestro proxy recuperamos el nombre del departamento
            Try
                nombre_dept = obj.NombreDepartamento(dept_emp)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                End
            End Try

            'Ponemos los datos de la persona que ha entrado al sistema y su ultima hoja de gastos
            Valores_informacion()

            'Llamamos al método que rellena la hoja y comprueba si es jefe de departamento o proyecto
            'En caso de serlo, rellena tambien su GroupBox con sus controles
            Rellenar_Hoja()


        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Metodo muestra la informacion del usuario que se autentica
    Private Sub Valores_informacion()

        Try

            'txtnombre.Enabled = False
            lblna.Text = nombre_emp
            lblna.Visible = True
            lblna.Location = New Size(55, 31)


            txtCod.BackColor = Color.White
            txtCod.ForeColor = Color.Blue
            txtCod.ReadOnly = True
            txtCod.Text = cod_emp.ToString

            txtDeparCod.BackColor = Color.White
            txtDeparCod.ForeColor = Color.Blue
            txtDeparCod.ReadOnly = True
            txtDeparCod.Text = dept_emp.ToString

            txtDepar.BackColor = Color.White
            txtDepar.ForeColor = Color.Blue
            txtDepar.ReadOnly = True
            txtDepar.Text = nombre_dept

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub


    'Metodo que recupera las hojas a través del proxy
    Private Sub RecuperarHojas()
        Try

            'El servicio nos devuelve un dataset. Como solo nos interesa la tabla hojas
            'la guardamos en nuestra tabla
            Dim datasetalt As New DataSet
            Dim TablaHojasUtil As New DataTable("Hoja")

            Try
                datasetalt = obj.DevolverHojas
            Catch ex As Exception
                MessageBox.Show(ex.Message + "El servicio está caido")
                End
            End Try


            TablaHojasUtil = datasetalt.Tables(0)
            TablaHojas = TablaHojasUtil.Copy

            'Liberamos memoria
            datasetalt.Dispose()
            TablaHojasUtil.Dispose()
        Catch ex As Exception
            MessageBox.Show(ex.Message + " Recuperarhojas")
        End Try
    End Sub

    'Metodo para mostrar la ultima hoja en el DataGridView y colocar el panel en caso
    ' de ser jefe de proyecto o jefe de departamento
    Private Sub Rellenar_Hoja()

        Try
            ' Colocamos el GroupBox y el DataGridView
            gbHojas.Controls.Clear()
            gbHojas.Location = New Size(48, 171)
            gbHojas.Size = New Size(619, 203)
            'dgvHoja.Location = New Size(31, 29)
            dgvHoja.Size = New Size(553, 41)


            'LLamo al metodo para conseguir la tabla de Hojas
            RecuperarHojas()



            ' Añadimos los objetos al GroupBox
            'gbHojas.Controls.Add(dgvHoja)
            gbHojas.Controls.Add(btnConsulta)
            gbHojas.Controls.Add(btnNuevaHoja)
            gbHojas.Controls.Add(PanelHoja)

            Dim test As Integer
            test = PanelHoja.Controls.Count

            PanelHoja.Controls.Clear()
            ' Conseguimos la ultima fila del empleaado y la mostramos en el DataGridView
            Dim ultimafila As DataRowView
            Dim dvHojasUser As DataView
            dvHojasUser = New DataView(TablaHojas)
            dvHojasUser.RowFilter = "Cod_emp = " + cod_emp.ToString

            'En caso de no haber creado hojas mostramos una etiqueta
            'En caso de haber y si está creada el boton mostrara Editar. Si tiene otro estado sera ver detalles
            Dim lblHoja As New Label
            If dvHojasUser.Count = 0 Then

                lblHoja.Text = "No hay ninguna hoja creada"
                lblHoja.Location = New Size(164, 30)
                lblHoja.Size = New Size(250, 20)
                lblHoja.ForeColor = Color.Red
                lblHoja.Font = New Font("Microsoft Sans Serif", 12)
                lblHoja.Visible = True
                PanelHoja.Controls.Add(lblHoja)
                dgvHoja.Visible = False
                btnDetalles.Visible = False
                btnConsulta.Enabled = False
                EstadoUltimaHoja = Nothing
            Else
                ultimafila = dvHojasUser.Item(dvHojasUser.Count - 1)
                UltimaHoja = ultimafila.Item(0)
                EstadoUltimaHoja = ultimafila.Item("Estado")

                If (EstadoUltimaHoja = "Creada") Then
                    btnDetalles.Text = "Editar Hoja"
                Else
                    btnDetalles.Text = "Detalles"
                End If

                dvHojasUser.RowFilter = "id_hoja =" + UltimaHoja.ToString
                dgvHoja.DataSource = dvHojasUser

                PanelHoja.Controls.Add(dgvHoja)
                PanelHoja.Controls.Add(btnDetalles)
                'lblHoja.Visible = False
                'PanelHoja.Controls.Clear()

                ' Definimos propiedades al DataGridView
                dgvHoja.Visible = True
                btnDetalles.Visible = True
                btnConsulta.Enabled = True
                dgvHoja.ReadOnly = True
                dgvHoja.AllowUserToAddRows = False
                dgvHoja.Columns("Cod_emp").Visible = False
                dgvHoja.Columns("Fecha_aprobacion").Visible = False
                dgvHoja.Columns("Fecha_autorizada").Visible = False
                dgvHoja.Columns("Cod_aprobada").Visible = False
                dgvHoja.Columns("Cod_autorizada").Visible = False
                dgvHoja.Columns("Fecha_creada").Visible = False
                dgvHoja.Columns("Motivo_Rechazo").Visible = False
                dgvHoja.Dock = DockStyle.Top
                dgvHoja.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
                dgvHoja.Columns(0).HeaderText = "Id"
                dgvHoja.Columns(6).HeaderText = "F.Origen"
                dgvHoja.Columns(7).HeaderText = "F.Destino"
                dgvHoja.Columns(9).HeaderText = "Creada"
            End If


            'Comprabamos si es jefe
            Comprobar_jefe_dept()

            'Si es jefe de departamento mostramos su administracion. Si no y si es de proyecto, mostramos su informacion.
            ' No puede ser jefe de departamento y de proyecto a la vez
            If (EsJefeDepartamento) Then
                rol = "JefeDepartamento"
                colocar_jefe_departamento()
            Else
                Comprobar_jefe_proy()
                If EsJefeProyecto Then
                    rol = "JefeProyecto"
                    colocar_jefe_proyecto()
                Else
                    rol = "Normal"
                End If
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Coloca los controles para un jefe de departamento
    Private Sub colocar_jefe_departamento()
        Try
            ' Cambiamos la posicion del GroupBox de las hojas y el boton. 
            'Tambien el tamaño de la ventana
            gbHojas.Location = New Size(48, 151)
            btnSalir.Location = New Size(572, 496)
            Me.Size = New Size(719, 560)

            ' Se configura el GroupBox y los botones y etiquetas correspondientes.
            gbGeneral.Controls.Clear()
            gbGeneral.Visible = True
            gbGeneral.Text = "Acciones sobre el departamento"
            gbGeneral.Location = New Size(48, 370)
            gbGeneral.Size = New Size(619, 120)

            Dim btnAprobarDep As New Button
            btnAprobarDep.Visible = True
            btnAprobarDep.Text = "Aprobar hojas pendientes"
            btnAprobarDep.Size = New Size(183, 26)
            btnAprobarDep.Location = New Size(33, 31)
            AddHandler btnAprobarDep.Click, AddressOf AprobarHoja

            Dim btnAutorizar As New Button
            btnAutorizar.Visible = True
            btnAutorizar.Text = "Autorizar hojas pendientes"
            btnAutorizar.Size = New Size(183, 26)
            btnAutorizar.Location = New Size(33, 82)
            AddHandler btnAutorizar.Click, AddressOf AutorizarHoja

            Dim btnConsultarHojasDep As New Button
            btnConsultarHojasDep.Visible = True
            btnConsultarHojasDep.Text = "Consultar hojas"
            btnConsultarHojasDep.Size = New Size(120, 30)
            btnConsultarHojasDep.Location = New Size(470, 52)
            AddHandler btnConsultarHojasDep.Click, AddressOf ConsultarHojasDepartamento

            Dim lblAprobar As New Label
            lblAprobar.Visible = True
            lblAprobar.Text = "Tienes hojas pendientes de aprobar"
            lblAprobar.Size = New Size(200, 13)
            lblAprobar.Location = New Size(236, 36)

            Dim lblAutorizar As New Label
            lblAutorizar.Visible = True
            lblAutorizar.Text = "Tienes hojas pendientes de aprobar"
            lblAutorizar.Size = New Size(200, 13)
            lblAutorizar.Location = New Size(236, 87)

            ' Creamos un contenedor para la linea y la creamos.
            Dim shcontainer As New ShapeContainer
            shcontainer.Parent = Me

            Dim lsDep As New LineShape
            lsDep.Visible = True
            lsDep.StartPoint = New System.Drawing.Point(450, 0)
            lsDep.EndPoint = New System.Drawing.Point(450, 96)
            lsDep.Parent = shcontainer

            ' Comprobamos si tiene hojas pendientes de aprobar y modificamos la label
            Dim expresion As String = ""

            dvHojasDepPendientesAprobar = New DataView(TablaHojas)
            expresion = "Estado = 'Abierta' AND Referencia = " + dept_emp.ToString
            dvHojasDepPendientesAprobar.RowFilter = expresion

            If (dvHojasDepPendientesAprobar.Count > 0) Then
                lblAprobar.Text = dvHojasDepPendientesAprobar.Count.ToString + " pendientes de aprobar"
                lblAprobar.ForeColor = Color.Green
                btnAprobarDep.Enabled = True
            Else
                lblAprobar.Text = "No hay hojas pendientes de aprobar"
                lblAprobar.ForeColor = Color.Red
                btnAprobarDep.Enabled = False

            End If

            ' Comprobamos si tiene hojas pendientes de autorizar y modificamos la label

            Dim TablaHojasPendientesAutorizar As DataTable
            TablaHojasPendientesAutorizar = obj.HojasAutorizar(dept_emp)
            dvHojasDepPendientesAutorizar = New DataView(TablaHojasPendientesAutorizar)

            If (dvHojasDepPendientesAutorizar.Count > 0) Then
                lblAutorizar.Text = dvHojasDepPendientesAutorizar.Count.ToString + " pendientes de autorizar"
                lblAutorizar.ForeColor = Color.Green
                btnAutorizar.Enabled = True
            Else
                lblAutorizar.Text = "No hay hojas pendientes de autorizar"
                lblAutorizar.ForeColor = Color.Red
                btnAutorizar.Enabled = False

            End If

            ' Añadimos los controles al GroupBox creado
            gbGeneral.Controls.Add(shcontainer)
            gbGeneral.Controls.Add(btnAprobarDep)
            gbGeneral.Controls.Add(btnAutorizar)
            gbGeneral.Controls.Add(btnConsultarHojasDep)
            gbGeneral.Controls.Add(lblAprobar)
            gbGeneral.Controls.Add(lblAutorizar)

            Me.Controls.Add(gbGeneral)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Coloca los controles para un jefe de proyecto
    Private Sub colocar_jefe_proyecto()
        Try
            ' Cambiamos la posicion del GroupBox de las hojas y el boton. Tambien el tamaño de la ventana

            gbHojas.Location = New Size(48, 151)
            btnSalir.Location = New Size(572, 456)
            Me.Size = New Size(719, 530)

            ' Se configuraGroupBox y los botones y etiquetas correspondientes.
            gbGeneral.Controls.Clear()
            gbGeneral.Visible = True
            gbGeneral.Text = "Acciones sobre el proyecto " + ProyectoResponsable.ToString
            gbGeneral.Location = New Size(48, 370)
            gbGeneral.Size = New Size(619, 80)

            Dim btnAprobarProy As New Button
            btnAprobarProy.Visible = True
            btnAprobarProy.Text = "Aprobar hojas pendientes"
            btnAprobarProy.Size = New Size(183, 26)
            btnAprobarProy.Location = New Size(33, 31)
            AddHandler btnAprobarProy.Click, AddressOf AprobarHojaProyecto

            Dim btnConsultarHojasProy As New Button
            btnConsultarHojasProy.Visible = True
            btnConsultarHojasProy.Text = "Consultar hojas"
            btnConsultarHojasProy.Size = New Size(120, 30)
            btnConsultarHojasProy.Location = New Size(470, 28)
            AddHandler btnConsultarHojasProy.Click, AddressOf ConsultarHojasProyecto

            Dim lblAprobar As New Label
            lblAprobar.Visible = True
            lblAprobar.Text = "Tienes hojas pendientes de aprobar"
            lblAprobar.Size = New Size(200, 13)
            lblAprobar.Location = New Size(236, 36)

            ' Creamos un contenedor para la linea y la creamos.
            Dim shcontainer As New ShapeContainer
            shcontainer.Parent = Me

            Dim lsDep As New LineShape
            lsDep.Visible = True
            lsDep.StartPoint = New System.Drawing.Point(450, 0)
            lsDep.EndPoint = New System.Drawing.Point(450, 56)
            lsDep.Parent = shcontainer

            ' Comprobamos si tiene hojas pendientes de aprobar y modificamos la label
            Dim expresion As String = ""

            dvHojasProyPendientesAprobar = New DataView(TablaHojas)
            expresion = "Estado = 'Abierta' AND Referencia = " + ProyectoResponsable.ToString
            dvHojasProyPendientesAprobar.RowFilter = expresion

            If (dvHojasProyPendientesAprobar.Count > 0) Then
                btnAprobarProy.Enabled = True
                lblAprobar.Text = dvHojasProyPendientesAprobar.Count.ToString + " pendientes de aprobar"
                lblAprobar.ForeColor = Color.Green
            Else
                lblAprobar.Text = "No hay hojas pendientes de aprobar"
                lblAprobar.ForeColor = Color.Red
                btnAprobarProy.Enabled = False
            End If


            ' Añadimos los controles al GroupBox creado
            gbGeneral.Controls.Add(shcontainer)
            gbGeneral.Controls.Add(btnAprobarProy)
            gbGeneral.Controls.Add(lblAprobar)
            gbGeneral.Controls.Add(btnConsultarHojasProy)

            Me.Controls.Add(gbGeneral)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Metodo comprobar si es jefe de departamento
    Private Function Comprobar_jefe_dept() As Boolean
        Try
            Try
                jefe_dept = obj.JefedeDepartamento(dept_emp)
                'obj.Close()
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                'Return
                End
            End Try

            ' Si es el propio usuario que ha entrado, es jefe de departamento.
            If jefe_dept = cod_emp Then
                EsJefeDepartamento = True
            Else
                EsJefeDepartamento = False
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        Return EsJefeDepartamento

    End Function

    'Metodo comprobar si es jefe de proyecto
    Private Function Comprobar_jefe_proy() As Boolean
        Try

            Try
                ProyectoResponsable = obj.JefedeProyecto(cod_emp)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                End
            End Try

            If ProyectoResponsable = 0 Then
                EsJefeProyecto = False
            Else
                EsJefeProyecto = True
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

        Return EsJefeProyecto

    End Function

    Private Sub btnSalir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSalir.Click
        Me.Close()
        Application.Exit()

    End Sub

    Private Sub btnConsulta_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnConsulta.Click
        Try
            'La consulta que abrimos es para consultar las propias hojas del empleado
            consulta = "Normal"

            'Abrimos el formulario de forma no modal, instalamos el evento para que cuando se
            'cierrre el nuevo frm mostremos el principal
            Dim frm As New frmConsultas
            AddHandler frm.FormClosing, AddressOf FormOnClosing
            frm.Show(Me)
            Me.Hide()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub


    Private Sub btnNuevaHoja_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNuevaHoja.Click
        Try
            'Si está cerrada o cancelada o no hay podemos abrir una nueva
            If (EstadoUltimaHoja = "Cerrada" Or EstadoUltimaHoja = "Cancelada" Or String.IsNullOrEmpty(EstadoUltimaHoja)) Then

                'Se abre de forma modal
                Using frm As New frmNuevaHoja
                    AddHandler frm.FormClosing, AddressOf FormOnClosing
                    frm.ShowDialog(Me)
                End Using

                'Actualizamos la hoja y los controles
                Rellenar_Hoja()
            Else
                MessageBox.Show("Solo puede tener una hoja activa", "Hojas Activas", MessageBoxButtons.OK, MessageBoxIcon.Information)
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnDetalles_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDetalles.Click
        Try

            'Si está en estado creada se edita, sino se ven los detalles
            If EstadoUltimaHoja = "Creada" Then
                Using ventana As New frmNuevaHoja(UltimaHoja)
                    ventana.ShowDialog(Me)
                End Using
            Else
                Using ventana As New frmDetallesHoja(UltimaHoja)
                    ventana.ShowDialog(Me)
                End Using
            End If


            'Actualizamos la hoja y los controles
            Rellenar_Hoja()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        
    End Sub

    Private Sub AprobarHoja()
        Try
            'Mostramos las hoja pendientes de aprobar de forma modal
            Aprobar = True
            Using frm As New frmResultado(dvHojasDepPendientesAprobar, True)
                frm.ShowDialog(Me)
            End Using

            'Actualizamos la hoja y los controles
            Rellenar_Hoja()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub AprobarHojaProyecto()
        Try
            'Mostramos las hoja pendientes de aprobar de forma modal
            Aprobar = True
            Using frm As New frmResultado(dvHojasProyPendientesAprobar, True)
                frm.ShowDialog(Me)
            End Using

            'Actualizamos la hoja y los controles
            Rellenar_Hoja()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub AutorizarHoja()
        Try
            'Mostramos las hoja pendientes de autorizar de forma modal
            Aprobar = False
            Using frm As New frmResultado(dvHojasDepPendientesAutorizar, True)
                frm.ShowDialog(Me)
            End Using

            'Actualizamos la hoja y los controles
            Rellenar_Hoja()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub ConsultarHojasDepartamento()
        Try
            'La consulta es de departamento
            consulta = "Departamento"

            'instalamos el evento para mostrar ya que lo abrimos de forma no modal.
            Dim frm As New frmConsultas
            AddHandler frm.FormClosing, AddressOf FormOnClosing
            frm.Show(Me)
            Me.Hide()


        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub ConsultarHojasProyecto()
        Try
            'La consulta es de proyecto
            consulta = "Proyecto"

            'instalamos el evento para mostrar ya que lo abrimos de forma no modal.
            Dim frm As New frmConsultas
            AddHandler frm.FormClosing, AddressOf FormOnClosing
            frm.Show(Me)
            Me.Hide()

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub FormOnClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs)
        Me.Show()
    End Sub


    Private Sub ActualizarToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ActualizarToolStripMenuItem.Click
        Try
            'Actualizamos la hoja y los controles
            Rellenar_Hoja()
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub AcercaDeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AcercaDeToolStripMenuItem.Click
        'Mostramos el form Acerca de, de forma modal
        Using frm As New frmAcercaDe()
            frm.ShowDialog(Me)
        End Using
    End Sub
End Class