﻿Imports System.Data.SqlClient
Imports System.IO


Public Class frmNuevaHoja

    Dim hoja_creada As Integer = 0
    Dim dtTiposGasto As New DataTable
    Dim TablaGastos As New DataTable("Gastos")
    Dim ValorGastoActual As Decimal
    Dim GastoTotal As Decimal = 0
    Dim Referencia As Integer
    Dim Editar As Boolean

    Dim CambiarValor As Boolean = True
    Dim datasetGastos As New DataSet

    Dim PreguntarAlCerrar As Boolean = True

    'Evento que controlamos
    Private Sub frmNuevaHoja_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Try
            If PreguntarAlCerrar Then
                Dim dr As DialogResult

                dr = MessageBox.Show("¿Está seguro que desea salir de esta hoja? Se perderán los cambios que no haya guardado", "Salir de hoja", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

                If dr = Windows.Forms.DialogResult.Yes Then
                    'Me.Close()
                Else
                    e.Cancel = True
                End If
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub


    Private Sub frmNuevaHoja_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try

            txtGastos.ReadOnly = True
            txtGastos.BackColor = Color.White

            dtTiposGasto = dataset.Tables("Tipos_gasto")


            'Creamos el DataGridView y sus columnas con los tipos correspondientes.
            'Columnas para el DataGridView
            Dim cbbTest As New DataGridViewComboBoxColumn
            cbbTest.DataSource = cbbPais.Items
            cbbTest.DataPropertyName = "Pais"
            cbbTest.HeaderText = "Pais"
            dgvGastos.Columns.Add(cbbTest)

            Dim ColConcepto As New DataGridViewTextBoxColumn
            ColConcepto.ValueType = Type.GetType("System.String")
            ColConcepto.HeaderText = "Concepto"
            ColConcepto.Name = "Concepto"
            ' ColConcepto.DefaultCellStyle.Format = "N0"
            dgvGastos.Columns.Add(ColConcepto)

            Dim ColUnidades As New DataGridViewTextBoxColumn
            ColUnidades.ValueType = Type.GetType("System.Int32")
            ColUnidades.HeaderText = "Unidades"
            ColUnidades.Name = "Unidades"
            ColUnidades.DefaultCellStyle.Format = "N0"
            dgvGastos.Columns.Add(ColUnidades)

            Dim ColImporte As New DataGridViewTextBoxColumn
            ColImporte.ValueType = Type.GetType("System.Decimal")
            ColImporte.HeaderText = "Importe"
            ColImporte.Name = "Importe"
            ColImporte.DefaultCellStyle.Format = "N2"
            dgvGastos.Columns.Add(ColImporte)

            Dim ColTotal As New DataGridViewTextBoxColumn
            ColTotal.ValueType = Type.GetType("System.Decimal")
            ColTotal.HeaderText = "Total"
            ColTotal.Name = "Total"
            ColTotal.DefaultCellStyle.Format = "N2"
            dgvGastos.Columns.Add(ColTotal)

            Dim idgasto As New DataGridViewTextBoxColumn
            idgasto.ValueType = Type.GetType("System.Int32")
            idgasto.HeaderText = "IdGasto"
            idgasto.Name = "IdGasto"
            idgasto.DefaultCellStyle.Format = "N0"
            dgvGastos.Columns.Add(idgasto)

            Dim fecha_gasto As New CalendarColumn
            'idgasto.ValueType = Type.GetType("System.Int32")
            fecha_gasto.HeaderText = "Fecha"
            fecha_gasto.Name = "fecha_gasto"
            dgvGastos.Columns.Add(fecha_gasto)

            dgvGastos.Columns(5).Visible = False
            'dgvGastos.Columns(6).Visible = False
            dgvGastos.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
            dgvGastos.AllowUserToAddRows = False

            dgvGastos.Columns(2).ReadOnly = True
            dgvGastos.Columns(3).ReadOnly = True
            dgvGastos.Columns(4).ReadOnly = True
            dgvGastos.Columns(4).DefaultCellStyle.BackColor = Color.Ivory

            'dgvGastos.Columns(6).DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleCenter

            'Ajustamos los controles
            If Today.Month = 1 Then
                dtpSalidaOrigen.MinDate = New DateTime(Today.Year - 1, 12, 1)
                dtpSalidaDestino.MinDate = New DateTime(Today.Year - 1, 12, 1)
            Else
                dtpSalidaOrigen.MinDate = New DateTime(Today.Year, Today.Month - 1, 1)
                dtpSalidaDestino.MinDate = New DateTime(Today.Year, Today.Month - 1, 1)
            End If

            dtpSalidaOrigen.MaxDate = New DateTime(Today.Year, Today.Month, 31)
            dtpSalidaDestino.MaxDate = New DateTime(Today.Year, Today.Month, 31)

            cbbPais.SelectedItem = "España"
            cbbPais.DropDownStyle = ComboBoxStyle.DropDownList
            txtGastos.Text = "0"


            'En caso de que sea editar una hoja, llamamos al metodo
            If Editar Then
                EditarHoja()
            Else
                btnAdd.PerformClick()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub


    'Existen dos tipos de llamadas. Cuando sea editar le pasamos la hoja, cuando sea nueva la creamos
    Public Sub New(ByVal cod_hoja As Integer)
        ' Llamada necesaria para el diseñador.
        InitializeComponent()

        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        hoja_creada = cod_hoja
        Editar = True
    End Sub

    Public Sub New()
        ' Llamada necesaria para el diseñador.
        InitializeComponent()

        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        Editar = False
    End Sub

    'Metodo que carga los datos en el formulario
    Private Sub EditarHoja()
        Try
            'Cargamos la hoja seleccionada en los controles del formulario
            Dim datasetALT As New DataSet
            Try
                datasetALT = obj.DatosHoja(hoja_creada)
            Catch ex As Exception
                MessageBox.Show(ex.Message + "El servicio está caido")
                End
            End Try

            Dim filahoja As DataRow
            filahoja = datasetALT.Tables(0).Rows.Find(hoja_creada)

            If (filahoja(2).ToString = dept_emp.ToString) Then
                rbDepartamento.Checked = True
            Else
                txtProyectos.Text = filahoja(2).ToString
                rbProyecto.Checked = True
            End If

            txtLocalidad.Text = filahoja(3)
            If filahoja(4).ToString = "" Then
            Else
                txtMotivos.Text = filahoja(4).ToString
            End If

            cbbPais.SelectedItem = filahoja(5)

            Dim caducada As Boolean = False
            If filahoja(6) >= dtpSalidaOrigen.MinDate Then
                dtpSalidaOrigen.Value = filahoja(6)
                If filahoja(7) >= dtpSalidaDestino.MinDate Then
                    dtpSalidaDestino.Value = filahoja(7)
                    caducada = False
                Else
                    caducada = True
                End If
            Else
                caducada = True

            End If

            'En caso de que una hoja esté caducada, la cancelamos y ponemos el motivo
            If caducada Then
                Dim motivo As String = "La hoja ha caducado"
                obj.RechazarHoja(hoja_creada, motivo)
                MessageBox.Show(motivo, "Hoja Caducada", MessageBoxButtons.OK, MessageBoxIcon.Information)
                Me.DialogResult = Windows.Forms.DialogResult.Cancel
                PreguntarAlCerrar = False
                Return
            End If

            txtGastos.Text = filahoja(8).ToString


            'Cargamos los gastos de la hoja
            Try
                datasetALT = obj.GastosdeHoja(hoja_creada)
            Catch ex As Exception
                MessageBox.Show(ex.Message + "El servicio está caido")
                End
            End Try

            Dim TablaALT As New DataTable("Gastos")
            TablaALT = datasetALT.Tables(0)

            TablaGastos = TablaALT.Copy
            datasetGastos.Tables.Add(TablaGastos)

            'Liberamos recursos
            TablaALT.Dispose()
            datasetALT.Dispose()


            Dim VistaGastosHoja As New DataView(datasetGastos.Tables(0))
            VistaGastosHoja.RowFilter = "Cod_hoja = " + hoja_creada.ToString

            Dim i As Integer = 0
            'Variable para que cuando añadamos los gastos no nos calcule nada
            CambiarValor = False
            For Each fila As DataRowView In VistaGastosHoja
                ' MessageBox.Show(fila.Item(0).ToString())
                dgvGastos.Rows.Add()
                dgvGastos.Item(0, i).Value = fila.Item(2)
                dgvGastos.Item(1, i).Value = fila.Item(3)
                dgvGastos.Item(2, i).Value = fila.Item(4)
                dgvGastos.Item(3, i).Value = fila.Item(5)
                dgvGastos.Item(4, i).Value = fila.Item(6)
                dgvGastos.Item(5, i).Value = fila.Item(0)
                dgvGastos.Item(6, i).Value = fila.Item(7)

                If fila.Item(4) <> 0 Then
                    'MessageBox.Show("Fila Unidades VACIA")
                    dgvGastos.Item(2, i).ReadOnly = False
                    dgvGastos.Item(3, i).Style.BackColor = Color.DarkGray
                Else
                    dgvGastos.Item(2, i).ReadOnly = True
                End If

                If fila.Item(5) <> 0 Then
                    dgvGastos.Item(3, i).ReadOnly = False
                    dgvGastos.Item(2, i).Style.BackColor = Color.DarkGray
                Else
                    dgvGastos.Item(3, i).ReadOnly = True
                    'MessageBox.Show("Fila Importe VACIA")
                End If
                i = i + 1
            Next

            'Restauramos su valor
            CambiarValor = True

        Catch ex As Exception
            MessageBox.Show(ex.Message + " EDITAR HOJA")
        End Try
    End Sub

    Private Sub pbValidar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbValidar.Click
        Try
            'Comprobamos si hay algun valor nulo que no permite validar la hoja
            Dim nulos As Boolean
            nulos = ComprobarValoresNulos()
            If nulos = False Then
                Return
            End If

            Dim dr As DialogResult
            dr = MessageBox.Show("¿Está seguro que desea solicitar el pago de esta hoja?", "Solicitud de pago", MessageBoxButtons.YesNo, MessageBoxIcon.Question)


            Dim DEC As Decimal
            Dim importe As String
            DEC = Convert.ToDecimal(txtGastos.Text)
            importe = Replace(DEC, ",", ".")
           

            If dr = Windows.Forms.DialogResult.Yes Then
                If Editar Then
                    ' Actualizamos la hoja
                    obj.SolicitarPagoHoja(Referencia, txtLocalidad.Text, dtpSalidaOrigen.Value.Date, dtpSalidaDestino.Value.Date, importe, cbbPais.SelectedItem.ToString, hoja_creada, txtMotivos.Text)


                    'Actualizamos los gastos
                    ActualizarGastosEditar()

                Else
                    ' Como es nueva, insertamos la hoja y guardamos los gastos
                    hoja_creada = obj.SolicitarPagoHojaNueva(cod_emp, Referencia, txtLocalidad.Text, dtpSalidaOrigen.Value.Date, dtpSalidaDestino.Value.Date, importe, cbbPais.SelectedItem.ToString, txtMotivos.Text)
                    'Al ser nueva, insertamos todos los gastos
                    For i As Integer = 0 To dgvGastos.Rows.Count - 1
                        obj.GuardarGastosHojaNueva(hoja_creada, dgvGastos.Item(0, i).Value.ToString, dgvGastos.Item(1, i).Value.ToString, dgvGastos.Item(2, i).Value, dgvGastos.Item(3, i).Value.ToString, dgvGastos.Item(4, i).Value.ToString, dgvGastos.Item(6, i).Value)
                    Next
                End If
            Else
                Return
            End If
            PreguntarAlCerrar = False
            Me.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message + " VALIDAR")
        End Try
    End Sub

    'Comprobamos los valores nulos que no pueden serlo
    Private Function ComprobarValoresNulos() As Boolean
        Try
            If txtLocalidad.Text = "" Then
                MessageBox.Show("Debe introducir una localidad", "Faltan datos", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return False
            End If

            If cbbPais.SelectedItem.ToString = "" Then
                MessageBox.Show("Debe elegir un País", "Faltan datos", MessageBoxButtons.OK, MessageBoxIcon.Error)
                Return False
            End If

            For i As Integer = 0 To dgvGastos.Rows.Count - 1
                Dim fila As Integer = i + 1
                If dgvGastos.Item(0, i).Value Is Nothing Then
                    MessageBox.Show("Debe elegir un País en el gasto numero " + fila.ToString, "Faltan datos", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return False
                End If

                If dgvGastos.Item(1, i).Value Is Nothing Then
                    MessageBox.Show("Debe elegir un concepto de gasto en el numero " + fila.ToString, "Faltan datos", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    Return False
                End If
            Next

            If (rbDepartamento.Checked = True) Then
                Referencia = dept_emp
            Else
                Referencia = txtProyectos.Text
            End If


            If dgvGastos.Rows.Count <> 0 Then

                Dim gasto As Integer = 1
                For i As Integer = 0 To dgvGastos.Rows.Count - 1
                    If dgvGastos.Item(6, i).Value < dtpSalidaOrigen.Value.Date Or dgvGastos.Item(6, i).Value > dtpSalidaDestino.Value.Date Then

                        MessageBox.Show("La fecha del gasto " + gasto.ToString + " no está correcta")
                        Return False
                    End If
                    gasto = gasto + 1
                Next


            Else
                Return False
            End If


            Return True
        Catch ex As Exception
            MessageBox.Show(ex.Message + " Comprobar")
            Return False
        End Try
    End Function

    'Metodo para Actualizar los gastos cuando se está editando una hoja
    Private Sub ActualizarGastosEditar()
        Try
            'Recorrer los gastos que hay en la vista
            'Si alguno ya estaba cargado y solo se ha modificado, se modifica. Sino se añade
            For i As Integer = 0 To dgvGastos.Rows.Count - 1
                If dgvGastos.Item(5, i).Value = 0 Then
                    'MessageBox.Show("test")
                    obj.GuardarGastosHojaNueva(hoja_creada, dgvGastos.Item(0, i).Value.ToString, dgvGastos.Item(1, i).Value.ToString, dgvGastos.Item(2, i).Value, dgvGastos.Item(3, i).Value.ToString, dgvGastos.Item(4, i).Value.ToString, dgvGastos.Item(6, i).Value)
                Else
                    obj.ActualizarGasto(dgvGastos.Item(5, i).Value, dgvGastos.Item(0, i).Value.ToString, dgvGastos.Item(1, i).Value.ToString, dgvGastos.Item(2, i).Value, dgvGastos.Item(3, i).Value.ToString, dgvGastos.Item(4, i).Value.ToString, dgvGastos.Item(6, i).Value)
                End If
            Next

            Dim VistaGastosHoja As New DataView(datasetGastos.Tables(0))
            VistaGastosHoja.RowFilter = "Cod_hoja = " + hoja_creada.ToString

            'Eliminamos los gastos que el usuario ha eliminado
            Dim y As Integer = 0
            For Each fila As DataRowView In VistaGastosHoja
                If (y < dgvGastos.Rows.Count) Then
                    If fila.Item(0) = dgvGastos.Item(5, y).Value Then
                        'MessageBox.Show("NO ELIMINADO")
                    Else
                        'MessageBox.Show(fila.Item(0).ToString + " ELIMINADO")
                        obj.EliminarGasto(fila.Item(0))
                    End If
                Else
                    'MessageBox.Show(fila.Item(0).ToString + " ELIMINADO")
                    obj.EliminarGasto(fila.Item(0))
                End If
                y = y + 1
            Next
        Catch ex As Exception
            MessageBox.Show(ex.Message + " ActualizarGastos")
        End Try

    End Sub

    Private Sub pbGuardar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbGuardar.Click
        Try
            Dim nulos As Boolean
            nulos = ComprobarValoresNulos()
            If nulos = False Then
                Return
            End If

            Dim dr As DialogResult
            dr = MessageBox.Show("¿Está seguro que desea guardar esta hoja?", "Guardar hoja", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

            If dr = Windows.Forms.DialogResult.Yes Then

                Dim DEC As Decimal
                Dim importe As String
                DEC = Convert.ToDecimal(txtGastos.Text)
                importe = Replace(DEC, ",", ".")

                If Editar Then
                    'Actualizamos los datos de la hoja
                    obj.ActualizarHojaGuardar(Referencia, txtLocalidad.Text, dtpSalidaOrigen.Value.Date, dtpSalidaDestino.Value.Date, importe, cbbPais.SelectedItem.ToString, hoja_creada, txtMotivos.Text)
                    'Actualizamos los gastos de la hoja
                    ActualizarGastosEditar()

                Else

                    'Como es nueva insertamos una nueva hoja
                    hoja_creada = obj.GuardarHojaNueva(cod_emp, Referencia, txtLocalidad.Text, dtpSalidaOrigen.Value.Date, dtpSalidaDestino.Value.Date, importe, cbbPais.SelectedItem.ToString, txtMotivos.Text)

                    'Insertamos todos los gastos
                    For i As Integer = 0 To dgvGastos.Rows.Count - 1
                        obj.GuardarGastosHojaNueva(hoja_creada, dgvGastos.Item(0, i).Value.ToString, dgvGastos.Item(1, i).Value.ToString, dgvGastos.Item(2, i).Value, dgvGastos.Item(3, i).Value.ToString, dgvGastos.Item(4, i).Value.ToString, dgvGastos.Item(6, i).Value)
                    Next
                End If

            Else
                Return
            End If

            PreguntarAlCerrar = False
            Me.Close()
        Catch ex As Exception
            MessageBox.Show(ex.Message + " Guardar")
        End Try
    End Sub

    Private Sub pbAdjuntar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbAdjuntar.Click
        Try
            'Antes de adjuntar tiene que estar creada
            If hoja_creada = 0 Then
                MessageBox.Show("Primero debe guardar la hoja")
                Return
            End If
            'MessageBox.Show(txtMotivos.Text)
            OpenFileDialog1.Filter = "Archivos PDF|*.pdf"
            OpenFileDialog1.Title = "Selecciona el archivo PDF a adjuntar"
            OpenFileDialog1.Multiselect = False
            If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                Dim datos As Byte()
                datos = GuardarArchivo(OpenFileDialog1.FileName.ToString)

                Dim dr As New DialogResult

                dr = MessageBox.Show("¿Desea adjuntar realmente este fichero? Se sobreescribirá en caso de haber uno", "Adjuntar fichero", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

                If dr = MsgBoxResult.Yes Then
                    obj.GuardarAdjunto(hoja_creada, datos)
                Else
                    Return
                End If

            Else

            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'funcion para guardar el archivo en la Base de datos
    Private Function GuardarArchivo(ByVal archivo As String) As Byte()
        If (Not (File.Exists(archivo))) Then Return Nothing
        Try
            Using fs As New FileStream(archivo, FileMode.Open, FileAccess.Read)
                Dim length As Int32 = Convert.ToInt32(fs.Length - 1)
                Dim datos() As Byte = New Byte(length) {}

                fs.Read(datos, 0, length)
                Return datos

            End Using

        Catch ex As Exception
            MessageBox.Show(ex.Message + "GUARDAR")
            Throw
        End Try

    End Function

    Private Sub pbImprimir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbImprimir.Click
        Try
            If PrintDialog1.ShowDialog() Then
                PrintForm1.PrinterSettings = PrintDialog1.PrinterSettings

                PrintForm1.Print()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub pbCancelar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles pbBorrar.Click
        Try
            If hoja_creada <> 0 Then
                Dim dr As DialogResult
                dr = MessageBox.Show("¿Está seguro que desea borrar esta hoja?", "Borrar hoja", MessageBoxButtons.YesNo, MessageBoxIcon.Question)

                If dr = Windows.Forms.DialogResult.Yes Then
                    obj.BorrarHoja(hoja_creada)
                    PreguntarAlCerrar = False
                    Me.Close()
                End If
            Else
                PreguntarAlCerrar = False
                Me.Close()
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Evento que controlamos para elegir el tipo de gasto
    Private Sub dgvGastos_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvGastos.CellClick
        Try
            If (e.ColumnIndex <> 1) Then
                Return
            End If

            If (e.RowIndex = -1) Then
                Return
            End If
            'MessageBox.Show(e.RowIndex)

            Using frm As New frmUtil
                frm.ConceptoGastos()

                Dim dr As DialogResult = frm.ShowDialog(Me)

                If (dr = DialogResult.OK) Then
                    'MessageBox.Show(frm.gasto_elegido)
                    dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value = frm.gasto_elegido

                    ValorGastoActual = frm.precio_gasto_elegido

                    If frm.gasto_elegido = "DCO" Or frm.gasto_elegido = "DID" Or frm.gasto_elegido = "DIM" Or frm.gasto_elegido = "KM" Then
                        'dgvGastos.Columns(3).ReadOnly = True
                        dgvGastos.Item(3, e.RowIndex).ReadOnly = True
                        dgvGastos.Item(3, e.RowIndex).Style.BackColor = Color.DarkGray
                        'dgvGastos.Columns(3).DefaultCellStyle.BackColor = Color.DarkGray
                        'dgvGastos.Columns(2).ReadOnly = False
                        dgvGastos.Item(2, e.RowIndex).ReadOnly = False
                        dgvGastos.Item(2, e.RowIndex).Style.BackColor = Color.White
                        'dgvGastos.Columns(2).DefaultCellStyle.BackColor = Color.White
                        'dgvGastos.Item(2, e.RowIndex).AdjustCellBorderStyle()
                        dgvGastos.Item(2, e.RowIndex).Value = "0"
                        dgvGastos.Item(3, e.RowIndex).Value = "0"
                        dgvGastos.Item(4, e.RowIndex).Value = "0"

                    Else
                        'dgvGastos.Columns(2).ReadOnly = True
                        'dgvGastos.Columns(2).DefaultCellStyle.BackColor = Color.DarkGray
                        'dgvGastos.Columns(3).ReadOnly = False
                        dgvGastos.Item(2, e.RowIndex).ReadOnly = True
                        dgvGastos.Item(2, e.RowIndex).Style.BackColor = Color.DarkGray
                        dgvGastos.Item(3, e.RowIndex).ReadOnly = False
                        dgvGastos.Item(3, e.RowIndex).Style.BackColor = Color.White
                        ' dgvGastos.Columns(3).DefaultCellStyle.BackColor = Color.White
                        dgvGastos.Item(2, e.RowIndex).Value = "0"
                        dgvGastos.Item(3, e.RowIndex).Value = "0"
                        dgvGastos.Item(4, e.RowIndex).Value = "0"
                    End If


                End If

            End Using

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
        ' MessageBox.Show("TEST")
    End Sub

    'Metodo para calcular el valor de un gasto
    Private Sub CalcularValor(ByVal e As System.Windows.Forms.DataGridViewCellEventArgs)
        Try
            'En caso de ser Domingo es un 20% mas. En caso de ser festivo un 40% más

            Dim fila As DataRow

            If dgvGastos.Item(1, e.RowIndex).Value = "" Then
            Else
                fila = dtTiposGasto.Rows.Find(dgvGastos.Item(1, e.RowIndex).Value)

                If dgvGastos.Item(2, e.RowIndex).ReadOnly Then

                Else
                    If dgvGastos.Item(2, e.RowIndex).Value.ToString <> 0 Then
                        dgvGastos.Item(4, e.RowIndex).Value = fila.Item(3).ToString * dgvGastos.Item(2, e.RowIndex).Value.ToString

                        If dgvGastos.Item(1, e.RowIndex).Value.ToString = "DID" Or dgvGastos.Item(1, e.RowIndex).Value.ToString = "DIM" Or dgvGastos.Item(1, e.RowIndex).Value.ToString = "DCO" Then
                            Dim fecha As Date
                            Dim valor As Decimal = 0
                            fecha = dgvGastos.Item(6, e.RowIndex).Value
                            If fecha.DayOfWeek = DayOfWeek.Sunday Then
                                valor = dgvGastos.Item(4, e.RowIndex).Value
                                dgvGastos.Item(4, e.RowIndex).Value = (valor * 0.2) + valor
                            Else
                                Dim festivo As Boolean
                                festivo = obj.ComprobarFestividad(fecha)
                                If festivo Then
                                    valor = dgvGastos.Item(4, e.RowIndex).Value
                                    dgvGastos.Item(4, e.RowIndex).Value = (valor * 0.4) + valor
                                    'MessageBox.Show("Es festivo")
                                Else
                                    ' MessageBox.Show("No es festivo")
                                End If
                                'implementar si es festivo
                                'valor = fila.Item(3).ToString * dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value.ToString
                                'dgvGastos.Item(4, e.RowIndex).Value = (valor * 0.4) + valor
                            End If

                        Else

                        End If
                    End If
                End If

            End If
        Catch ex As Exception
            Throw
        End Try
    End Sub

    'Evento para calcular los gastos mediante el metodo anterior y para controlar las fechas
    Private Sub dgvGastos_CellValidated(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvGastos.CellValidated
        Try

            If (e.ColumnIndex = 2) Then
                CalcularValor(e)
            End If


            If (e.ColumnIndex = 3) Then

                If dgvGastos.Item(e.ColumnIndex, e.RowIndex).ReadOnly Then
                Else
                    dgvGastos.Item(4, e.RowIndex).Value = dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value.ToString
                End If

            End If

            If e.ColumnIndex = 6 Then
                If dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value < dtpSalidaOrigen.Value.Date Then
                    MessageBox.Show("La fecha no puede ser menor que la fecha de la hoja", "Error fecha", MessageBoxButtons.OK, MessageBoxIcon.Error)
                    'dgvGastos.CancelEdit()
                    dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value = dtpSalidaOrigen.Value.Date
                Else
                    If dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value > dtpSalidaDestino.Value.Date Then
                        MessageBox.Show("La fecha no puede ser mayor que la fecha de la hoja", "Error fecha", MessageBoxButtons.OK, MessageBoxIcon.Error)
                        dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value = dtpSalidaDestino.Value.Date
                        ' dgvGastos.CancelEdit()
                    End If
                End If

                CalcularValor(e)

                'Dim unidades As Integer = dgvGastos.Item(2, e.RowIndex).Value
                'dgvGastos.Item(2, e.RowIndex).Value = 0
                'dgvGastos.Item(2, e.RowIndex).Value = unidades
                'dgvGastos.Item(2, e.RowIndex).Selected = True
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message + "CELL")
        End Try
    End Sub

    Private Sub dgvGastos_CellValidating(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellValidatingEventArgs) Handles dgvGastos.CellValidating
        If e.ColumnIndex = 2 Then
            If dgvGastos.Item(e.ColumnIndex, e.RowIndex).ReadOnly Then
                Return
            End If
            If dgvGastos.Item(6, e.RowIndex).Value Is Nothing Then
                MessageBox.Show("Debe rellenar primero la fecha del gasto", "Error fecha", MessageBoxButtons.OK, MessageBoxIcon.Information)
                ' dgvGastos.Item(e.ColumnIndex, e.RowIndex).Value = 0
                dgvGastos.CancelEdit()
                ' Return
            End If
        End If


    End Sub

    'Evento para sumar el importe total
    Private Sub dgvGastos_CellValueChanged(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles dgvGastos.CellValueChanged

        Try

            If CambiarValor = False Then
                Return
            End If

            If (e.ColumnIndex = 4) Then
                GastoTotal = 0
                For index As Integer = 1 To dgvGastos.Rows.Count
                    If dgvGastos.Item(4, index - 1).Value <> 0 Then
                        GastoTotal = GastoTotal + dgvGastos.Item(4, index - 1).Value
                    End If

                Next

                txtGastos.Text = GastoTotal.ToString

            End If

            'txtGastos.Text = GastoTotal.ToString
        Catch ex As Exception
            MessageBox.Show(ex.Message + "VALUECHANGED")
        End Try

    End Sub

    Private Sub dgvGastos_DataError(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewDataErrorEventArgs) Handles dgvGastos.DataError
        If (e.Exception IsNot Nothing) Then
            dgvGastos.CancelEdit()
        End If
    End Sub

    Private Sub rbProyecto_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbProyecto.CheckedChanged
        Try
            If rbProyecto.Checked = True Then
                'txtProyectos.Enabled = True
                btnProyectos.Enabled = True

                If txtProyectos.Text = "" Then
                    btnProyectos.PerformClick()
                End If

            Else
                txtProyectos.Text = ""
                txtProyectos.Enabled = False
                btnProyectos.Enabled = False
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnProyectos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProyectos.Click
        Using frm As New frmUtil()


            frm.ProyectosAbiertosEmpleado()

            Dim dr As DialogResult = frm.ShowDialog(Me)

            If (dr = Windows.Forms.DialogResult.OK) Then
                txtProyectos.Text = CStr(frm.Proyecto_elegido)
            Else
                If dr = Windows.Forms.DialogResult.Ignore Then
                    rbDepartamento.Checked = True
                Else
                    MessageBox.Show("Debe seleccionar un proyecto", "Proyecto no seleccionado", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    rbDepartamento.Checked = True
                End If
            End If

        End Using
    End Sub

    'Eliminamos la ultima fila
    Private Sub btnRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnRemove.Click
        Try
            If dgvGastos.Rows.Count > 1 Then
                dgvGastos.Rows.RemoveAt(dgvGastos.Rows.Count - 1)
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    'Añadimos una fila mas
    Private Sub btnAdd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        Try
            dgvGastos.Rows.Add()

            dgvGastos.Item(2, dgvGastos.Rows.Count - 1).ReadOnly = True
            dgvGastos.Item(2, dgvGastos.Rows.Count - 1).Style.BackColor = Color.DarkGray
            dgvGastos.Item(3, dgvGastos.Rows.Count - 1).ReadOnly = True
            dgvGastos.Item(3, dgvGastos.Rows.Count - 1).Style.BackColor = Color.DarkGray
            dgvGastos.Item(4, dgvGastos.Rows.Count - 1).ReadOnly = True
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub dtpSalidaDestino_Validating(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles dtpSalidaDestino.Validating
        If dtpSalidaDestino.Value < dtpSalidaOrigen.Value Then
            MessageBox.Show("Fecha destino tiene que ser posterior a Fecha origen", "Error en fecha destino", MessageBoxButtons.OK, MessageBoxIcon.Error)
            'dtpSalidaDestino.Value = Today.Date
            dtpSalidaDestino.ResetText()
            'dtpSalidaOrigen.Focus()
        End If
    End Sub


End Class