﻿Imports System.Data.SqlClient

Public Class frmUtil

    Dim AdapHoja As New SqlDataAdapter
    Private valor_proyecto_elegido As Integer
    Private valor_gasto_elegido As String = ""
    Private valor_precio_gasto As Decimal
    Private DataSetProyectos As New DataSet
    Private hayproyectos As Boolean = True
    Private TablaProyectos As New DataTable
    Private TablaTiposGastos As New DataTable
    Private Proyecto As Boolean = True

    Private Sub frmUtil_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If hayproyectos = False Then
            Me.DialogResult = DialogResult.Ignore
        End If

    End Sub

    Private Sub frmUtil_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Try

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Public ReadOnly Property Proyecto_elegido As Integer
        Get
            Return valor_proyecto_elegido
        End Get
    End Property

    Public ReadOnly Property gasto_elegido As String
        Get
            Return valor_gasto_elegido
        End Get
    End Property

    Public ReadOnly Property precio_gasto_elegido As String
        Get
            Return valor_precio_gasto
        End Get
    End Property

    Private Sub dgvPrincipal_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgvPrincipal.DoubleClick
        Try


            Dim indice As Integer

            indice = Me.dgvPrincipal.CurrentCell.RowIndex

            If Proyecto Then
                valor_proyecto_elegido = Me.dgvPrincipal.Item(0, indice).Value
            Else
                valor_gasto_elegido = Me.dgvPrincipal.Item(0, indice).Value
            End If


            Me.DialogResult = DialogResult.OK

            'MessageBox.Show(proyecto_elegido)

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    'Metodo para obtener los proyectos en los que ha trabajado un empleado
    Public Sub ProyectosTrabajaEmpleado()
        Try
            Proyecto = True

            Dim datasetALT As New DataSet
            Dim TablaAlt As New DataTable

            Try
                datasetALT = obj.ProyectosTrabajaEmpleado(cod_emp)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                End
            End Try

            TablaAlt = datasetALT.Tables(0)
            dtHojas = TablaAlt.Copy
            datasetALT.Dispose()
            TablaAlt.Dispose()


            dgvPrincipal.DataSource = dtHojas
            dgvPrincipal.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
            dgvPrincipal.Dock = DockStyle.Fill
            dgvPrincipal.ReadOnly = True
            dgvPrincipal.AllowUserToAddRows = False
            dgvPrincipal.Columns(0).HeaderText = "Código de proyecto"
            dgvPrincipal.Columns(1).HeaderText = "Descripción del proyecto"

            If dgvPrincipal.RowCount = 0 Then
                lblTitulo.Text = "No hay hojas de gastos cargadas a ningun proyecto"
                lblTitulo.ForeColor = Color.Red
                lblTitulo.Font = New Font("Microsoft Sans Serif", 11, FontStyle.Bold)
                lblTitulo.Location = New Size(20, 100)
                dgvPrincipal.Visible = False
                panelData.Visible = False
                hayproyectos = False
            Else
                lblTitulo.Text = "Seleccione el proyecto"
                lblTitulo.ForeColor = Color.Blue
                lblTitulo.Font = New Font("Microsoft Sans Serif", 10)
                lblTitulo.Location = New Size(120, 9)
                panelData.Visible = True
                dgvPrincipal.Visible = True
                hayproyectos = True
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    'Metodo que da los proyectos abiertos en los que está un empleado
    'Para cargar las hojas nuevas
    Public Sub ProyectosAbiertosEmpleado()
        Try
            Proyecto = True

            Dim datasetALT As New DataSet
            Dim TablaAlt As New DataTable

            Try
                datasetALT = obj.ProyectosAbiertosEmpleado(cod_emp)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                End
            End Try

            TablaAlt = datasetALT.Tables(0)
            dtHojas = TablaAlt.Copy
            datasetALT.Dispose()
            TablaAlt.Dispose()



            dgvPrincipal.DataSource = dtHojas
            dgvPrincipal.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
            dgvPrincipal.ReadOnly = True
            dgvPrincipal.AllowUserToAddRows = False

            If dgvPrincipal.RowCount = 0 Then
                lblTitulo.Text = "No hay proyectos abiertos para poder cargar la hoja"
                lblTitulo.Location = New Size(20, 100)
                lblTitulo.Font = New Font("Microsoft Sans Serif", 11, FontStyle.Bold)
                lblTitulo.ForeColor = Color.Red
                dgvPrincipal.Visible = False
                panelData.Visible = False
                hayproyectos = False
            Else
                lblTitulo.Text = "Seleccione el proyecto"
                lblTitulo.ForeColor = Color.Blue
                lblTitulo.Font = New Font("Microsoft Sans Serif", 10)
                lblTitulo.Location = New Size(120, 9)
                panelData.Visible = True
                dgvPrincipal.Visible = True
                hayproyectos = True
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    'Metodo que carga los proyectos de un departamento
    Public Sub ProyectosDepartamento()
        Try
            Proyecto = True

            Dim datasetALT As New DataSet
            Dim TablaAlt As New DataTable

            Try
                datasetALT = obj.ProyectosDepartamento(dept_emp)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                End
            End Try

            TablaAlt = datasetALT.Tables(0)
            TablaProyectos = TablaAlt.Copy
            datasetALT.Dispose()
            TablaAlt.Dispose()

            CargarDatos()



        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    'Metodo que carga los datos
    Private Sub CargarDatos()
        Try
            dgvPrincipal.DataSource = TablaProyectos
            dgvPrincipal.ReadOnly = True
            dgvPrincipal.AllowUserToAddRows = False

            If dgvPrincipal.RowCount = 0 Then

                lblTitulo.Location = New Size(20, 100)
                lblTitulo.Font = New Font("Microsoft Sans Serif", 11, FontStyle.Bold)
                lblTitulo.ForeColor = Color.Red
                dgvPrincipal.Visible = False
                panelData.Visible = False
                hayproyectos = False
                lblTitulo.Text = "No hay proyectos asignados a este departamento"
            Else
                lblTitulo.Text = "Seleccione el proyecto"
                lblTitulo.ForeColor = Color.Blue
                lblTitulo.Font = New Font("Microsoft Sans Serif", 10)
                lblTitulo.Location = New Size(120, 9)
                dgvPrincipal.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill
                panelData.Visible = True
                dgvPrincipal.Visible = True
                hayproyectos = True
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    'Metodo qeu muestra los tipos de gastos en el formulario
    Public Sub ConceptoGastos()
        Try
            Proyecto = False
            TablaTiposGastos = dataset.Tables("Tipos_gasto")

            lblTitulo.Text = "Seleccion el tipo de gasto"

            dgvPrincipal.DataSource = TablaTiposGastos
            dgvPrincipal.ReadOnly = True
            dgvPrincipal.AllowUserToAddRows = False
            dgvPrincipal.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.DisplayedCells
            dgvPrincipal.Columns(3).Visible = False
            dgvPrincipal.Columns(0).HeaderText = "Código"
            dgvPrincipal.Columns(1).HeaderText = "Denominación"
            dgvPrincipal.Columns(2).HeaderText = "Descripción"


            Me.Size = New Size(650, 480)
            panelData.Size = New Size(630, 460)
            dgvPrincipal.Size = New Size(555, 400)

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
End Class